# struct Time::Location::Zone

- Time::Location::Zone
- Struct
- Value
- Object

##
Overview

A `Zone` represents a time zone offset in effect in a specific `Location`.

Some zones have a `#name` or abbreviation (such as `PDT`, `CEST`). For an unnamed zone the formatted offset should be used as name.

##
Defined in:

##
Constant Summary

UTC = `new("UTC", 0, false)`

  This is the `UTC` time zone with offset `+00:00`.

  It is the only zone offset used in `Time::Location::UTC`.

##
Constructors

- .new(name : String?, offset : Int32, dst : Bool)

  Creates a new `Zone` named name with offset from UTC in seconds.

##
Instance Method Summary

- #dst? : Bool

  Returns `true` if this zone offset is daylight savings time.

- #format(io : IO, with_colon = true, with_seconds = :auto)

  Prints `#offset` to io in the format `+HH:mm:ss`.

- #format(with_colon = true, with_seconds = :auto)

  Returns the `#offset` formatted as `+HH:mm:ss`.

- #inspect(io : IO) : Nil

  Prints this `Zone` to io.

- #name : String

  Returns the name of the zone.

- #offset : Int32

  Returns the offset from UTC in seconds.

### Instance methods inherited from struct `Struct`

==(other) : Bool ==, hash(hasher) hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io : IO) : Nil to_s

### Instance methods inherited from struct `Value`

==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, __crystal_pseudo_! : Bool __crystal_pseudo_!, __crystal_pseudo_as(type : Class) __crystal_pseudo_as, __crystal_pseudo_as?(type : Class) __crystal_pseudo_as?, __crystal_pseudo_is_a?(type : Class) : Bool __crystal_pseudo_is_a?, __crystal_pseudo_nil? : Bool __crystal_pseudo_nil?, __crystal_pseudo_responds_to?(name : Symbol) : Bool __crystal_pseudo_responds_to?, class class, dup dup, hash(hasher)
hash hash, inspect : String
inspect(io : IO) : Nil inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.new(name : String?, offset : Int32, dst : Bool) #

Creates a new `Zone` named name with offset from UTC in seconds. The parameter dst is used to declare this zone as daylight savings time.

If `#name` is `nil`, the formatted `#offset` will be used as `#name` (see `#format`).

Raises `InvalidTimezoneOffsetError` if seconds is outside the supported value range `-86_400..86_400` seconds (`-24:00` to `+24:00`).

##
Instance Method Detail

def dst? : Bool #

Returns `true` if this zone offset is daylight savings time.

def format(io : IO, with_colon = true, with_seconds = :auto) #

Prints `#offset` to io in the format `+HH:mm:ss`. When with_colon is `false`, the format is `+HHmmss`.

When with_seconds is `false`, seconds are omitted; when `:auto`, seconds are omitted if `0`.

def format(with_colon = true, with_seconds = :auto) #

Returns the `#offset` formatted as `+HH:mm:ss`. When with_colon is `false`, the format is `+HHmmss`.

When with_seconds is `false`, seconds are omitted; when `:auto`, seconds are omitted if `0`.

def inspect(io : IO) : Nil #

Prints this `Zone` to io.

It contains the `#name`, hour-minute-second format (see `#format`), `#offset` in seconds and `"DST"` if `#dst?`, otherwise `"STD"`.

def name : String #

Returns the name of the zone.

def offset : Int32 #

Returns the offset from UTC in seconds.